diff --git a/gnu/packages/crates-tls.scm b/gnu/packages/crates-tls.scm
index 382a162dad..05f5d5538c 100644
--- a/gnu/packages/crates-tls.scm
+++ b/gnu/packages/crates-tls.scm
@@ -40,6 +40,7 @@ (define-module (gnu packages crates-tls)
   #:use-module (gnu packages crates-windows)
   #:use-module (gnu packages crypto)
   #:use-module (gnu packages golang)
+  #:use-module (gnu packages jemalloc)
   #:use-module (gnu packages perl)
   #:use-module (gnu packages pkg-config)
   #:use-module (gnu packages rust-apps)
@@ -1146,8 +1147,52 @@ (define-public rust-rcgen-0.8
         ("rust-webpki" ,rust-webpki-0.22)
         ("rust-x509-parser" ,rust-x509-parser-0.12))))))
 
+(define-public rust-rustls-0.23
+  (package
+    (name "rust-rustls")
+    (version "0.23.7")
+    (source
+     (origin
+       (method url-fetch)
+       (uri (crate-uri "rustls" version))
+       (file-name (string-append name "-" version ".tar.gz"))
+       (sha256
+        (base32 "0yv7bh16rwhn6fnlb3wnixb2y4in9gf3z3ysa8k3zbgh3nbdpfzb"))))
+    (build-system cargo-build-system)
+    (arguments
+     (list
+      #:tests? #f          ; Not all files included.
+      #:cargo-inputs (list rust-aws-lc-rs-1
+                           rust-hashbrown-0.14
+                           rust-log-0.4
+                           rust-once-cell-1
+                           rust-ring-0.17
+                           rust-rustls-pki-types-1
+                           rust-rustls-webpki-0.102
+                           rust-rustversion-1
+                           rust-subtle-2
+                           rust-zeroize-1)
+      #:cargo-development-inputs (list rust-base64-0.22
+                                       rust-bencher-0.1
+                                       rust-env-logger-0.10
+                                       rust-log-0.4
+                                       rust-num-bigint-0.4
+                                       rust-rcgen-0.13
+                                       rust-rustls-pemfile-2
+                                       rust-tikv-jemallocator-0.5
+                                       rust-time-0.3
+                                       rust-webpki-roots-0.26)
+      #:phases override-jemalloc))
+    (native-inputs (list cmake-minimal pkg-config jemalloc))
+    (home-page "https://github.com/rustls/rustls")
+    (synopsis "Modern TLS library written in Rust")
+    (description
+     "This package provides a modern TLS library written in Rust.")
+    (license (list license:asl2.0 license:isc license:expat))))
+
 (define-public rust-rustls-0.22
   (package
+    (inherit rust-rustls-0.23)
     (name "rust-rustls")
     (version "0.22.2")
     (source
@@ -1157,7 +1202,6 @@ (define-public rust-rustls-0.22
        (file-name (string-append name "-" version ".tar.gz"))
        (sha256
         (base32 "0hcxyhq6ynvws9v5b2h81s1nwmijmya7a3vyyyhsy1wqpmb9jz78"))))
-    (build-system cargo-build-system)
     (arguments
      `(#:tests? #f          ; Not all files included.
        #:cargo-inputs (("rust-aws-lc-rs" ,rust-aws-lc-rs-1)
@@ -1168,17 +1212,13 @@ (define-public rust-rustls-0.22
                        ("rust-rustversion" ,rust-rustversion-1)
                        ("rust-subtle" ,rust-subtle-2)
                        ("rust-zeroize" ,rust-zeroize-1))
-       #:cargo-development-inputs (("rust-base64" ,rust-base64-0.21)
-                                   ("rust-bencher" ,rust-bencher-0.1)
-                                   ("rust-env-logger" ,rust-env-logger-0.10)
-                                   ("rust-log" ,rust-log-0.4)
-                                   ("rust-rustls-pemfile" ,rust-rustls-pemfile-2)
-                                   ("rust-webpki-roots" ,rust-webpki-roots-0.26))))
-    (home-page "https://github.com/rustls/rustls")
-    (synopsis "Modern TLS library written in Rust")
-    (description
-     "This package provides a modern TLS library written in Rust.")
-    (license (list license:asl2.0 license:isc license:expat))))
+       #:cargo-development-inputs
+       (("rust-base64" ,rust-base64-0.21)
+        ("rust-bencher" ,rust-bencher-0.1)
+        ("rust-env-logger" ,rust-env-logger-0.10)
+        ("rust-log" ,rust-log-0.4)
+        ("rust-rustls-pemfile" ,rust-rustls-pemfile-2)
+        ("rust-webpki-roots" ,rust-webpki-roots-0.26))))))
 
 (define-public rust-rustls-0.21
   (package