diff --git a/gnu/packages/check.scm b/gnu/packages/check.scm
index b7116b3f0e2..6042f763f15 100644
--- a/gnu/packages/check.scm
+++ b/gnu/packages/check.scm
@@ -3675,7 +3675,6 @@ (define-public python-pytest-regressions
            python-pandas
            python-pillow
            python-restructuredtext-lint
-           python-tox
            python-setuptools-scm
            python-pytest))
     (home-page "https://github.com/ESSS/pytest-regressions")
diff --git a/gnu/packages/diffoscope.scm b/gnu/packages/diffoscope.scm
index 67567a6b310..bfe4ce99fdc 100644
--- a/gnu/packages/diffoscope.scm
+++ b/gnu/packages/diffoscope.scm
@@ -273,7 +273,6 @@ (define-public reprotest
        ("python-magic " ,python-magic)
        ("python-pytest " ,python-pytest)
        ("python-tlsh" ,python-tlsh)
-       ("python-tox" ,python-tox)
        ("unzip" ,unzip)
        ("xxd" ,xxd)))
     (build-system python-build-system)
diff --git a/gnu/packages/django.scm b/gnu/packages/django.scm
index 298968d37c6..f5b1e0462bb 100644
--- a/gnu/packages/django.scm
+++ b/gnu/packages/django.scm
@@ -260,7 +260,6 @@ (define-public python-django-extensions
     (native-inputs
      (list python-mock
            python-factory-boy
-           python-tox
            python-pytest
            python-pytest-cov
            python-pytest-django
diff --git a/gnu/packages/logging.scm b/gnu/packages/logging.scm
index a757c22154f..3c593001d00 100644
--- a/gnu/packages/logging.scm
+++ b/gnu/packages/logging.scm
@@ -134,7 +134,7 @@ (define-public tailon
          "0xkmrivzilsc9wqr8ms67v7399gxnh7pv5687k4rdpdgz4309fwc"))))
     (build-system python-build-system)
     (native-inputs
-     (list python-tox python-wheel))
+     (list python-wheel))
     (inputs
      (list python-pyyaml-5 python-sockjs-tornado python-tornado-http-auth
            python-tornado python-deepmerge))
diff --git a/gnu/packages/messaging.scm b/gnu/packages/messaging.scm
index cb72bfb3e25..35ff807e12c 100644
--- a/gnu/packages/messaging.scm
+++ b/gnu/packages/messaging.scm
@@ -3504,8 +3504,6 @@ (define-public python-harmony
                (base32
                 "1bm9xcnzpnpj6rlhbrnl2abwclzl7ivgh1vb5644y9mnhcs489js"))))
     (build-system python-build-system)
-    (native-inputs
-     (list python-tox))
     (inputs
      (list python-librecaptcha python-keyring python-requests))
     (synopsis "Discord account management")
diff --git a/gnu/packages/python-check.scm b/gnu/packages/python-check.scm
index ed3625421ae..8fd3a8924f1 100644
--- a/gnu/packages/python-check.scm
+++ b/gnu/packages/python-check.scm
@@ -419,7 +419,6 @@ (define-public python-vcrpy
            python-pytest
            python-pytest-cov
            python-pytest-httpbin
-           python-tox
            python-urllib3))
     (home-page "https://github.com/kevin1024/vcrpy")
     (synopsis "Automatically mock your HTTP interactions")
diff --git a/gnu/packages/python-web.scm b/gnu/packages/python-web.scm
index 8265ef41aff..51753adae77 100644
--- a/gnu/packages/python-web.scm
+++ b/gnu/packages/python-web.scm
@@ -2134,7 +2134,6 @@ (define-public python-omnipath
            python-pytest-socket
            python-requests-mock
            python-setuptools-scm
-           python-tox
            python-setuptools
            python-wheel))
     (home-page "https://omnipathdb.org/")
@@ -7640,7 +7639,6 @@ (define-public python-sanic
            python-setuptools
            python-slotscheck
            python-towncrier
-           python-tox
            python-types-ujson
            python-uvicorn
            python-wheel))
diff --git a/gnu/packages/python-xyz.scm b/gnu/packages/python-xyz.scm
index 446326afc74..c83146372bf 100644
--- a/gnu/packages/python-xyz.scm
+++ b/gnu/packages/python-xyz.scm
@@ -1308,8 +1308,7 @@ (define-public python-lunr
      (list python-hatch-fancy-pypi-readme
            python-hatchling
            python-pytest
-           python-pytest-timeout
-           python-tox))
+           python-pytest-timeout))
     (propagated-inputs
      (list python-importlib-metadata python-typing-extensions))
     (home-page
@@ -2695,8 +2694,7 @@ (define-public python-bidict
            python-sortedcollections
            python-sortedcontainers
            python-sphinx
-           python-sphinx-autodoc-typehints
-           python-tox))
+           python-sphinx-autodoc-typehints))
     (arguments
      `(#:phases (modify-phases %standard-phases
                   (add-after 'unpack 'relax-reqs
@@ -4513,7 +4511,6 @@ (define-public python-jsonargparse
            python-pytest
            python-pytest-subtests
            python-responses
-           python-tox
            python-types-requests
            python-setuptools
            python-wheel))
@@ -5677,7 +5674,6 @@ (define-public python-ddlparse
      (list python-pytest
            python-pytest-cov
            python-setuptools
-           python-tox
            python-wheel))
     (propagated-inputs (list python-pyparsing))
     (home-page "https://github.com/shinichi-takii/ddlparse")
@@ -6219,7 +6215,6 @@ (define-public python-virtualenv-clone
                               (delete-file "tox.ini")
                               (invoke "pytest" "-vvv" "tests")))))))
     (native-inputs (list python-pytest
-                         python-tox
                          python-virtualenv
                          python-wheel
                          python-tomli
@@ -11342,7 +11337,7 @@ (define-public python-honcho
         (base32 "1y0r8dw4pqcq7r4n58ixjdg1iy60lp0gxsd7d2jmhals16ij71rj"))))
     (build-system python-build-system)
     (native-inputs
-     (list python-pytest python-mock python-tox which)) ;for tests
+     (list python-pytest python-mock which)) ;for tests
     (propagated-inputs
      (list python-jinja2))
     (arguments
@@ -20129,7 +20124,7 @@ (define-public python-pdfminer-six
     (propagated-inputs
      (list python-chardet python-cryptography python-sortedcontainers))
     (native-inputs
-     (list python-nose python-tox))
+     (list python-nose))
     (home-page "https://github.com/pdfminer/pdfminer.six")
     (synopsis "PDF parser and analyzer")
     (description "@code{pdfminer.six} is a community maintained fork of
@@ -21276,9 +21271,7 @@ (define-public python-shshsh
          "1wzqyj1a6jj6cyv5ymzy834qm2lyq80yy1kfz0q0zayq9gm1cj7f"))))
     (build-system pyproject-build-system)
     (native-inputs
-     (list python-poetry-core
-           python-pytest
-           python-tox))
+     (list python-poetry-core python-pytest))
     (home-page "https://github.com/zqqqqz2000/shshsh")
     (synopsis "Write Shell commands simply and safely within Python")
     (description "This package provides a way to write Shell commands from
@@ -25144,8 +25137,7 @@ (define-public python-marshmallow-jsonapi
            python-flake8-bugbear
            python-flask
            python-mock
-           python-pytest
-           python-tox))
+           python-pytest))
     (home-page "https://github.com/marshmallow-code/marshmallow-jsonapi")
     (synopsis "JSON:API 1.0 formatting with Marshmallow")
     (description
@@ -25209,7 +25201,6 @@ (define-public python-apispec-webframeworks
            python-pytest
            python-pyyaml
            python-tornado
-           python-tox
            python-wheel))
     (home-page "https://github.com/marshmallow-code/apispec-webframeworks")
     (synopsis "Web framework plugins for apispec")
@@ -26667,7 +26658,7 @@ (define-public bpython
            python-watchdog
            python-jedi))
     (native-inputs
-     (list python-sphinx python-mock python-tox python-wheel))
+     (list python-sphinx python-mock python-wheel))
     (home-page "https://bpython-interpreter.org/")
     (synopsis "Fancy interface to the Python interpreter")
     (description "Bpython is a fancy interface to the Python
@@ -32933,7 +32924,6 @@ (define-public python-loguru
                          python-sphinx
                          python-sphinx-autobuild
                          python-sphinx-rtd-theme
-                         python-tox
                          python-setuptools
                          python-wheel))
     (home-page "https://github.com/Delgan/loguru")
@@ -35290,8 +35280,7 @@ (define-public python-ansicolors
         (base32 "1q3jqglkq4z0f6nkkn8bswcwqg012i2grrc27kabr8286dg4zycr"))))
     (build-system python-build-system)
     (native-inputs
-     (list python-tox
-           python-pytest-cov
+     (list python-pytest-cov
            unzip))
     (home-page "https://github.com/jonathaneunice/colors/")
     (synopsis "ANSI colors for Python")
diff --git a/gnu/packages/radio.scm b/gnu/packages/radio.scm
index 56e674a8edc..bfd601564d8 100644
--- a/gnu/packages/radio.scm
+++ b/gnu/packages/radio.scm
@@ -3171,8 +3171,7 @@ (define-public chirp
              python-pep8
              python-pytest
              python-pytest-mock
-             python-pyyaml
-             python-tox))
+             python-pyyaml))
       (inputs
        (list python-future
              python-importlib-resources
diff --git a/gnu/packages/terminals.scm b/gnu/packages/terminals.scm
index e424e41a222..d61dc6cb3c7 100644
--- a/gnu/packages/terminals.scm
+++ b/gnu/packages/terminals.scm
@@ -1199,7 +1199,6 @@ (define-public python-halo
     (native-inputs
      (list python-nose
            python-setuptools
-           python-tox
            python-twine
            python-wheel))
     (home-page "https://github.com/manrajgrover/halo")
@@ -1228,7 +1227,7 @@ (define-public python-log-symbols
                      (("(.*)==(.*)$" _ dep ver)
                       (string-append dep ">=" ver))))))))
     (propagated-inputs (list python-colorama))
-    (native-inputs (list python-nose python-setuptools python-tox python-wheel))
+    (native-inputs (list python-nose python-setuptools python-wheel))
     (home-page "https://github.com/manrajgrover/py-log-symbols")
     (synopsis "Python library with graphical symbols for logging on the terminal")
     (description "This package provides a Python library with graphical symbols
@@ -1255,7 +1254,7 @@ (define-public python-spinners
                    (substitute* "requirements-dev.txt"
                      (("(.*)==(.*)$" _ dep ver)
                       (string-append dep ">=" ver))))))))
-    (native-inputs (list python-nose python-setuptools python-tox python-wheel))
+    (native-inputs (list python-nose python-setuptools python-wheel))
     (home-page "https://github.com/manrajgrover/py-spinners")
     (synopsis "Python library with graphical spinners for the terminal")
     (description "Spinners is a Python library that contains graphical spinners