diff --git a/gnu/packages/node.scm b/gnu/packages/node.scm
index a9d4e5ab13..92aba7b376 100644
--- a/gnu/packages/node.scm
+++ b/gnu/packages/node.scm
@@ -668,72 +668,9 @@ (define-public node-llparse-bootstrap
 
 (define-public llhttp-bootstrap
   (package
-    (name "llhttp")
-    (version "6.0.11")
-    (source (origin
-              (method git-fetch)
-              (uri (git-reference
-                    (url "https://github.com/nodejs/llhttp.git")
-                    (commit (string-append "v" version))))
-              (file-name (git-file-name name version))
-              (sha256
-               (base32
-                "16gaylka6nx9bsff9xga3s8xihxm3k7svrb88lr4dj2s4pzlfga9"))
-              (modules '((guix build utils)))
-              (snippet
-               '(begin
-                  ;; Fix imports for esbuild.
-                  ;; https://github.com/evanw/esbuild/issues/477
-                  (substitute* "src/llhttp/http.ts"
-                    (("\\* as assert") "assert"))
-                  (substitute* "Makefile"
-                    (("npx ts-node bin/generate.ts")
-                     "node bin/generate.js"))
-                  #t))))
-    (build-system gnu-build-system)
-    (arguments
-     `(#:tests? #f                      ; no tests
-       #:make-flags (list (string-append "CLANG=" ,(cc-for-target))
-                          (string-append "DESTDIR=" (assoc-ref %outputs "out"))
-                          "PREFIX=")
-       #:phases
-       (modify-phases %standard-phases
-         (replace 'configure
-           (lambda* (#:key inputs native-inputs #:allow-other-keys)
-             (let ((esbuild (search-input-file (or native-inputs inputs)
-                                               "/bin/esbuild")))
-               (invoke esbuild
-                       "--platform=node"
-                       "--outfile=bin/generate.js"
-                       "--bundle" "bin/generate.ts"))))
-         (add-before 'install 'create-install-directories
-           (lambda* (#:key outputs #:allow-other-keys)
-             (let ((out (assoc-ref outputs "out")))
-               (for-each (lambda (dir)
-                           (mkdir-p (string-append out dir)))
-                         (list "/lib" "/include" "/src"))
-               #t)))
-         (add-after 'install 'install-src
-           (lambda* (#:key outputs #:allow-other-keys)
-             (let* ((out (assoc-ref outputs "out"))
-                    (src-dir (string-append out "/src")))
-               (install-file "build/c/llhttp.c" src-dir)
-               (install-file "src/native/api.c" src-dir)
-               (install-file "src/native/http.c" src-dir)
-               #t))))))
-    (native-inputs
-     `(("esbuild" ,esbuild)
-       ("node" ,node-bootstrap)
-       ("node-semver" ,node-semver-bootstrap)
-       ("node-llparse-bootstrap" ,node-llparse-bootstrap)))
-    (home-page "https://github.com/nodejs/llhttp")
-    (properties '((hidden? . #t)))
-    (synopsis "Parser for HTTP messages")
-    (description "This is a rewrite of
-@url{https://github.com/nodejs/http-parser, http-parser} using
-@url{https://github.com/nodejs/llparse, llparse} to generate the C
-source files.")
-    (license license:expat)))
+    (inherit llhttp)
+    (version "6.1.0")
+    (properties '((hidden? . #t)))))
 
 (define-public node-lts
   (package

base-commit: 612e4dd98f7d1d015e405af9d029bede3fe3c280
-- 
2.45.1


From c0c47b25ffa1f8f9520661568b1d394bb745d721 Mon Sep 17 00:00:00 2001
Message-ID: <c0c47b25ffa1f8f9520661568b1d394bb745d721.1718488151.git.ashvithshetty10@gmail.com>
In-Reply-To: <361a358ac968efb4148512054e62f0f211abf7f7.1718488151.git.ashvithshetty10@gmail.com>
References: <361a358ac968efb4148512054e62f0f211abf7f7.1718488151.git.ashvithshetty10@gmail.com>
From: Ashvith Shetty <ashvithshetty10@gmail.com>
Date: Sun, 16 Jun 2024 03:12:48 +0530
Subject: [PATCH 2/2] gnu: node-lts: Update to 18.19.1.

* gnu/packages/node.scm (node-lts): Update to 18.19.1.
[arguments]: Remove obsolete 'delete-problematic-tests phase.

Change-Id: I533490d0ebdb28e2fbffc5ce5bfee7100319ff1a
---
 gnu/packages/node.scm | 16 ++--------------
 1 file changed, 2 insertions(+), 14 deletions(-)

diff --git a/gnu/packages/node.scm b/gnu/packages/node.scm
index 92aba7b376..52e719cdb0 100644
--- a/gnu/packages/node.scm
+++ b/gnu/packages/node.scm
@@ -675,14 +675,14 @@ (define-public llhttp-bootstrap
 (define-public node-lts
   (package
     (inherit node)
-    (version "18.19.0")
+    (version "18.19.1")
     (source (origin
               (method url-fetch)
               (uri (string-append "https://nodejs.org/dist/v" version
                                   "/node-v" version ".tar.gz"))
               (sha256
                (base32
-                "05qc1dgmrms73073n4l36jrcxf6ygqj959d3cngy5qclrg0isk6x"))
+                "028bqb9006v1k859jdan0ycvcamq8w3j5pjdgmjk79x5g7vs6yk3"))
               (modules '((guix build utils)))
               (snippet
                '(begin
@@ -800,18 +800,6 @@ (define-public node-lts
                (for-each delete-file
                          '("test/parallel/test-tls-passphrase.js"
                            "test/parallel/test-tls-server-verify.js"))))
-           (add-after 'delete-problematic-tests 'replace-llhttp-sources
-             (lambda* (#:key inputs #:allow-other-keys)
-               ;; Replace pre-generated llhttp sources
-               (let ((llhttp (assoc-ref inputs "llhttp")))
-                 (copy-file (string-append llhttp "/src/llhttp.c")
-                            "deps/llhttp/src/llhttp.c")
-                 (copy-file (string-append llhttp "/src/api.c")
-                            "deps/llhttp/src/api.c")
-                 (copy-file (string-append llhttp "/src/http.c")
-                            "deps/llhttp/src/http.c")
-                 (copy-file (string-append llhttp "/include/llhttp.h")
-                            "deps/llhttp/include/llhttp.h"))))
            ;; npm installs dependencies by copying their files over a tar
            ;; stream.  A file with more than one hardlink is marked as a
            ;; "Link".  pacote/lib/fetcher.js calls node-tar's extractor with a